Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -8764,6 +8654,6 @@
 !--             For each hour of year:
                 IF ( check_existence( aero_emission_att%var_names, 'nhoursyear' ) )  THEN
-                   CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nhoursyear,&
-                                                                'nhoursyear' )
+                   CALL netcdf_data_input_get_dimension_length( id_salsa,                          &
+                                                        aero_emission_att%nhoursyear, 'nhoursyear' )
                    ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
                                                    1:aero_emission_att%nhoursyear) )
@@ -8790,26 +8680,31 @@
 !
 !--             Get chemical composition (i.e. mass fraction of different species) in aerosols
-                ALLOCATE( aero_emission%def_mass_fracs(1:aero_emission_att%ncat,                   &
-                                                       1:aero_emission_att%ncc) )
-                aero_emission%def_mass_fracs = 0.0_wp
-                CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%def_mass_fracs,  &
-                                   0, aero_emission_att%ncc-1, 0, aero_emission_att%ncat-1 )
+                IF ( check_existence( aero_emission_att%var_names, 'emission_mass_fracs' ) )  THEN
+                   ALLOCATE( aero_emission%def_mass_fracs(1:aero_emission_att%ncat,                &
+                                                          1:aero_emission_att%ncc) )
+                   aero_emission%def_mass_fracs = 0.0_wp
+                   CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%def_mass_fracs,&
+                                      0, aero_emission_att%ncc-1, 0, aero_emission_att%ncat-1 )
+                ELSE
+                   message_string = 'Missing emission_mass_fracs in ' //  TRIM( input_file_salsa )
+                   CALL message( 'salsa_emission_setup', 'PA0659', 1, 2, 0, 6, 0 )
+                ENDIF
 !
 !--             If the chemical component is not activated, set its mass fraction to 0 to avoid
 !--             inbalance between number and mass flux
-                cc_i2m = aero_emission_att%cc_input_to_model
-                IF ( index_so4 < 0  .AND.  cc_i2m(1) /= 0 )                                        &
+                cc_i2m = aero_emission_att%cc_in2mod
+                IF ( index_so4 < 0  .AND.  cc_i2m(1) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(1)) = 0.0_wp
-                IF ( index_oc  < 0  .AND.  cc_i2m(2) /= 0 )                                        &
+                IF ( index_oc  < 0  .AND.  cc_i2m(2) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(2)) = 0.0_wp
-                IF ( index_bc  < 0  .AND.  cc_i2m(3) /= 0 )                                        &
+                IF ( index_bc  < 0  .AND.  cc_i2m(3) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(3)) = 0.0_wp
-                IF ( index_du  < 0  .AND.  cc_i2m(4) /= 0 )                                        &
+                IF ( index_du  < 0  .AND.  cc_i2m(4) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(4)) = 0.0_wp
-                IF ( index_ss  < 0  .AND.  cc_i2m(5) /= 0 )                                        &
+                IF ( index_ss  < 0  .AND.  cc_i2m(5) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(5)) = 0.0_wp
-                IF ( index_no  < 0  .AND.  cc_i2m(6) /= 0 )                                        &
+                IF ( index_no  < 0  .AND.  cc_i2m(6) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(6)) = 0.0_wp
-                IF ( index_nh  < 0  .AND.  cc_i2m(7) /= 0 )                                        &
+                IF ( index_nh  < 0  .AND.  cc_i2m(7) > 0 )                                         &
                                                   aero_emission%def_mass_fracs(:,cc_i2m(7)) = 0.0_wp
 !
@@ -8886,11 +8781,22 @@
 !
 !--             Read time stamps:
-                CALL get_variable( id_salsa, 'time', aero_emission_att%time )
+                IF ( check_existence( aero_emission_att%var_names, 'time' ) )  THEN
+                   CALL get_variable( id_salsa, 'time', aero_emission_att%time )
+                ELSE
+                   message_string = 'Missing time in ' //  TRIM( input_file_salsa )
+                   CALL message( 'salsa_emission_setup', 'PA0660', 1, 2, 0, 6, 0 )
+                ENDIF
 !
 !--             Read emission mass fractions
-                CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%preproc_mass_fracs )
+                IF ( check_existence( aero_emission_att%var_names, 'emission_mass_fracs' ) )  THEN
+                   CALL get_variable( id_salsa, 'emission_mass_fracs',                             &
+                                      aero_emission%preproc_mass_fracs )
+                ELSE
+                   message_string = 'Missing emission_mass_fracs in ' //  TRIM( input_file_salsa )
+                   CALL message( 'salsa_emission_setup', 'PA0659', 1, 2, 0, 6, 0 )
+                ENDIF
 !
 !--             If the chemical component is not activated, set its mass fraction to 0
-                cc_i2m = aero_emission_att%cc_input_to_model
+                cc_i2m = aero_emission_att%cc_in2mod
                 IF ( index_so4 < 0  .AND.  cc_i2m(1) /= 0 )                                        &
                    aero_emission%preproc_mass_fracs(cc_i2m(1)) = 0.0_wp
@@ -8970,10 +8876,10 @@
 !--             only for either default, land or urban surface.
                 IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-                   CALL set_flux( surf_def_h(0), aero_emission_att%cc_input_to_model,              &
+                   CALL set_flux( surf_def_h(0), aero_emission_att%cc_in2mod,                      &
                                   aero_emission%def_mass_fracs(in,:), source_array )
                 ELSE
-                   CALL set_flux( surf_usm_h, aero_emission_att%cc_input_to_model,                 &
+                   CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                         &
                                   aero_emission%def_mass_fracs(in,:), source_array )
-                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_input_to_model,                 &
+                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                         &
                                   aero_emission%def_mass_fracs(in,:), source_array )
                 ENDIF
@@ -9004,10 +8910,10 @@
 !--          for either default, land and urban surface.
              IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-                CALL set_flux( surf_def_h(0), aero_emission_att%cc_input_to_model,                 &
+                CALL set_flux( surf_def_h(0), aero_emission_att%cc_in2mod,                         &
                                aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
              ELSE
-                CALL set_flux( surf_usm_h, aero_emission_att%cc_input_to_model,                    &
+                CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                            &
                                aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
-                CALL set_flux( surf_lsm_h, aero_emission_att%cc_input_to_model,                    &
+                CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                            &
                                aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
              ENDIF
@@ -9249,6 +9155,8 @@
 
     INTEGER(iwp) ::  id_chem        !< NetCDF id of chemistry emission file
+    INTEGER(iwp) ::  i              !< loop index
     INTEGER(iwp) ::  ig             !< loop index
     INTEGER(iwp) ::  in             !< running index for emission categories
+    INTEGER(iwp) ::  j              !< loop index
     INTEGER(iwp) ::  num_vars       !< number of variables
 
@@ -9258,4 +9166,8 @@
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_factor  !< emission time factor
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  dum_var_3d  !<
+
+    REAL(wp), DIMENSION(:,:,:,:,:), ALLOCATABLE ::  dum_var_5d  !<
 
 !
@@ -9280,14 +9192,17 @@
 !
 !--    Read the index and name of chemical components
-       CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nspec,              &
+       CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%n_emiss_species,    &
                                                     'nspecies' )
-       ALLOCATE( chem_emission_att%species_index(1:chem_emission_att%nspec) )
+       ALLOCATE( chem_emission_att%species_index(1:chem_emission_att%n_emiss_species) )
        CALL get_variable( id_chem, 'emission_index', chem_emission_att%species_index )
        CALL get_variable( id_chem, 'emission_name', chem_emission_att%species_name,                &
-                          chem_emission_att%nspec )
+                          chem_emission_att%n_emiss_species )
+!
+!--    Allocate emission data
+       ALLOCATE( chem_emission(1:chem_emission_att%n_emiss_species) )
 !
 !--    Find the corresponding indices in the model
        emission_index_chem = 0
-       DO  ig = 1, chem_emission_att%nspec
+       DO  ig = 1, chem_emission_att%n_emiss_species
           in_name = chem_emission_att%species_name(ig)
           SELECT CASE ( TRIM( in_name ) )
@@ -9366,9 +9281,20 @@
 !--       Allocate and read surface emission data (in total PM) (NOTE that "preprocessed" input data
 !--       array is applied now here)
-          ALLOCATE( chem_emission%preproc_emission_data(nys:nyn,nxl:nxr, 1:chem_emission_att%nspec,&
-                                                        1:chem_emission_att%ncat) )
-          CALL get_variable( id_chem, 'emission_values', chem_emission%preproc_emission_data,      &
-                             0, chem_emission_att%ncat-1, 0, chem_emission_att%nspec-1,            &
-                             nxl, nxr, nys, nyn )
+          ALLOCATE( dum_var_5d(1,nys:nyn,nxl:nxr,1:chem_emission_att%n_emiss_species,              &
+                               1:chem_emission_att%ncat) )
+          CALL get_variable( id_chem, 'emission_values', dum_var_5d, 0, chem_emission_att%ncat-1,  &
+                             0, chem_emission_att%n_emiss_species-1, nxl, nxr, nys, nyn, 0, 0 )
+          DO  ig = 1, chem_emission_att%n_emiss_species
+             ALLOCATE( chem_emission(ig)%default_emission_data(nys:nyn,nxl:nxr,                    &
+                                                               1:chem_emission_att%ncat) )
+             DO  in = 1, chem_emission_att%ncat
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      chem_emission(ig)%default_emission_data(j,i,in) = dum_var_5d(1,j,i,ig,in)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDDO
+          DEALLOCATE( dum_var_5d )
 !
 !--    Pre-processed mode:
@@ -9412,17 +9338,23 @@
 !
 !--    Set gas emissions for each emission category
+       ALLOCATE( dum_var_3d(nys:nyn,nxl:nxr,1:chem_emission_att%n_emiss_species) )
+
        DO  in = 1, chem_emission_att%ncat
+          DO  ig = 1, chem_emission_att%n_emiss_species
+             dum_var_3d(:,:,ig) = chem_emission(ig)%default_emission_data(:,:,in)
+          ENDDO
 !
 !--       Set surface fluxes only for either default, land or urban surface
           IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
              CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,       &
-                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+                                dum_var_3d(:,:,in), time_factor(in) )
           ELSE
              CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,          &
-                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+                                dum_var_3d(:,:,in), time_factor(in) )
              CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,          &
-                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+                                dum_var_3d(:,:,in), time_factor(in) )
           ENDIF
        ENDDO
+       DEALLOCATE( dum_var_3d )
 !
 !--    The next emission update is again after one hour
@@ -9438,25 +9370,26 @@
 !--    Allocate the data input array always before reading in the data and deallocate after (NOTE 
 !--    that "preprocessed" input data array is applied now here)
-       ALLOCATE( chem_emission%default_emission_data(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+       ALLOCATE( dum_var_5d(1,1,nys:nyn,nxl:nxr,1:chem_emission_att%n_emiss_species) )
 !
 !--    Read in the next time step
-       CALL get_variable( id_chem, 'emission_values', chem_emission%default_emission_data,         &
-                          chem_emission_att%i_hour, 0, chem_emission_att%nspec-1, nxl, nxr, nys, nyn )
+       CALL get_variable( id_chem, 'emission_values', dum_var_5d,                                  &
+                          0, chem_emission_att%n_emiss_species-1, nxl, nxr, nys, nyn, 0, 0,        &
+                          chem_emission_att%i_hour, chem_emission_att%i_hour )
 !
 !--    Set surface fluxes only for either default, land or urban surface
        IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
           CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,          &
-                             chem_emission%default_emission_data )
+                             dum_var_5d(1,1,:,:,:) )
        ELSE
           CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,             &
-                             chem_emission%default_emission_data )
+                             dum_var_5d(1,1,:,:,:) )
           CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,             &
-                             chem_emission%default_emission_data )
-       ENDIF
+                             dum_var_5d(1,1,:,:,:) )
+       ENDIF
+       DEALLOCATE ( dum_var_5d )
 !
 !--    Determine the next emission update
        next_gas_emission_update = gas_emission_time(chem_emission_att%i_hour+2)
 
-       DEALLOCATE( chem_emission%default_emission_data )
     ENDIF
 !
@@ -9506,5 +9439,5 @@
        REAL(wp), DIMENSION(ngases_salsa) ::  conv     !< unit conversion factor
 
-       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,chem_emission_att%nspec), INTENT(in) ::  source_array  !<
+       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,chem_emission_att%n_emiss_species), INTENT(in) ::  source_array  !<
 
        TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
@@ -9581,41 +9514,138 @@
     CHARACTER(LEN=*) ::  var      !<
 
-    SELECT CASE ( TRIM( var ) )
-
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
-          IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
-             CALL message( 'check_parameters', 'PA0652', 1, 2, 0, 6, 0 )
-          ENDIF
-          IF (  salsa_gases_from_chem )  THEN
-             message_string = 'gases are imported from the chemistry module and thus output of "'  &
-                               // TRIM( var ) // '" is not allowed'
-             CALL message( 'check_parameters', 'PA0653', 1, 2, 0, 6, 0 )
-          ENDIF
+    INTEGER(iwp) ::  char_to_int   !< for converting character to integer
+
+    IF ( var(1:6) /= 'salsa_' )  THEN
+       unit = 'illegal'
+       RETURN
+    ENDIF
+!
+!-- Treat bin-specific outputs separately
+    IF ( var(7:11) ==  'N_bin' )  THEN
+       READ( var(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
           unit = '#/m3'
-
-       CASE ( 'LDSA' )
-          IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
-             CALL message( 'check_parameters', 'PA0646', 1, 2, 0, 6, 0 )
-          ENDIF
-          unit = 'mum2/cm3'
-
-       CASE ( 'm_bin1', 'm_bin2',  'm_bin3',  'm_bin4',  'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
-              'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12', 'PM2.5',  'PM10',   's_BC',   's_DU',     &
-              's_H2O',  's_NH',    's_NO',    's_OC',    's_SO4',  's_SS' )
-          IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
-             CALL message( 'check_parameters', 'PA0647', 1, 2, 0, 6, 0 )
-          ENDIF
+       ELSE
+          unit = 'illegal'
+          RETURN
+       ENDIF
+
+    ELSEIF ( var(7:11) ==  'm_bin' )  THEN
+       READ( var(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
           unit = 'kg/m3'
-
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',  'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8',    &
-              'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12', 'Ntot' )
-          IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
-             CALL message( 'check_parameters', 'PA0645', 1, 2, 0, 6, 0 )
-          ENDIF
-          unit = '#/m3'
+       ELSE
+          unit = 'illegal'
+          RETURN
+       ENDIF
+
+    ELSE
+       SELECT CASE ( TRIM( var(7:) ) )
+
+          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
+             IF (  salsa_gases_from_chem )  THEN
+                message_string = 'gases are imported from the chemistry module and thus output '// &
+                                 'of "' // TRIM( var ) // '" is not allowed'
+                CALL message( 'check_parameters', 'PA0653', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = '#/m3'
+
+          CASE ( 'LDSA' )
+             unit = 'mum2/cm3'
+
+          CASE ( 'PM0.1', 'PM2.5', 'PM10', 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC',        &
+                 's_SO4', 's_SS' )
+             unit = 'kg/m3'
+
+          CASE ( 'N_UFP', 'Ntot' )
+             unit = '#/m3'
+
+          CASE DEFAULT
+             unit = 'illegal'
+
+       END SELECT
+    ENDIF
+
+ END SUBROUTINE salsa_check_data_output
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check profile data output for salsa. Currently only for diagnostic variables
+!> Ntot, N_UFP, PM0.1, PM2.5, PM10 and LDSA
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_check_data_output_pr( var, var_count, unit, dopr_unit )
+
+    USE arrays_3d,                                                                                 &
+        ONLY: zu
+
+    USE profil_parameter,                                                                          &
+        ONLY:  dopr_index
+
+    USE statistics,                                                                                &
+        ONLY:  hom, pr_palm, statistic_regions
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*) ::  dopr_unit  !<
+    CHARACTER(LEN=*) ::  unit       !<
+    CHARACTER(LEN=*) ::  var        !<
+
+    INTEGER(iwp) ::  var_count     !<
+
+    IF ( var(1:6) /= 'salsa_' )  THEN
+       unit = 'illegal'
+       RETURN
+    ENDIF
+
+    SELECT CASE ( TRIM( var(7:) ) )
+
+       CASE( 'LDSA' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 1
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = 'mum2/cm3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+
+       CASE( 'N_UFP' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 2
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = '#/m3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+
+       CASE( 'Ntot' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 3
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = '#/m3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+
+       CASE( 'PM0.1' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 4
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = 'kg/m3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+
+       CASE( 'PM2.5' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 5
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = 'kg/m3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+
+       CASE( 'PM10' )
+          salsa_pr_count = salsa_pr_count + 1
+          salsa_pr_index(salsa_pr_count) = 6
+          dopr_index(var_count) = pr_palm + salsa_pr_count
+          dopr_unit = 'kg/m3'
+          unit = dopr_unit
+          hom(:,2,dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
 
        CASE DEFAULT
@@ -9624,5 +9654,167 @@
     END SELECT
 
- END SUBROUTINE salsa_check_data_output
+
+ END SUBROUTINE salsa_check_data_output_pr
+
+!-------------------------------------------------------------------------------!
+!> Description:
+!> Calculation of horizontally averaged profiles for salsa.
+!-------------------------------------------------------------------------------!
+ SUBROUTINE salsa_statistics( mode, sr, tn )
+
+    USE control_parameters,                                                                        &
+        ONLY:  max_pr_user
+
+    USE chem_modules,                                                                              &
+        ONLY:  max_pr_cs
+
+    USE statistics,                                                                                &
+        ONLY:  pr_palm, rmask, sums_l
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*) ::  mode  !<
+
+    INTEGER(iwp) ::  i    !< loop index
+    INTEGER(iwp) ::  ib   !< loop index
+    INTEGER(iwp) ::  ic   !< loop index
+    INTEGER(iwp) ::  ii   !< loop index
+    INTEGER(iwp) ::  ind  !< index in the statistical output
+    INTEGER(iwp) ::  j    !< loop index
+    INTEGER(iwp) ::  k    !< loop index
+    INTEGER(iwp) ::  sr   !< statistical region
+    INTEGER(iwp) ::  tn   !< thread number
+
+    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles depositing in the alveolar
+                           !< (or tracheobronchial) region of the lung. Depends on the particle size
+    REAL(wp) ::  mean_d    !< Particle diameter in micrometres
+    REAL(wp) ::  temp_bin  !< temporary variable
+
+    IF ( mode == 'profiles' )  THEN
+       !$OMP DO
+       DO  ii = 1, salsa_pr_count
+
+          ind = pr_palm + max_pr_user + max_pr_cs + ii
+
+          SELECT CASE( salsa_pr_index(ii) )
+
+             CASE( 1 )  ! LDSA
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+   !
+   !--                      Diameter in micrometres
+                            mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+   !
+   !--                      Deposition factor: alveolar
+                            df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +    &
+                                   2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -  &
+                                   1.362_wp )**2 ) )
+   !
+   !--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                            temp_bin = temp_bin + pi * mean_d**2 * df * 1.0E-6_wp *                &
+                                       aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE( 2 )  ! N_UFP
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )                          &
+                               temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE( 3 )  ! Ntot
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE( 4 )  ! PM0.1
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE( 5 )  ! PM2.5
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE( 6 )  ! PM10
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         sums_l(k,ind,tn) = sums_l(k,ind,tn) + temp_bin * rmask(j,i,sr)  *         &
+                                           MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+          END SELECT
+       ENDDO
+
+    ELSEIF ( mode == 'time_series' )  THEN
+!
+!--    TODO
+    ENDIF
+
+ END SUBROUTINE salsa_statistics
+
 
 !------------------------------------------------------------------------------!
@@ -9643,4 +9835,5 @@
     CHARACTER(LEN=*)  ::  variable   !<
 
+    INTEGER(iwp) ::  char_to_int  !< for converting character to integer
     INTEGER(iwp) ::  found_index  !<
     INTEGER(iwp) ::  i            !<
@@ -9653,5 +9846,4 @@
                           !< (or tracheobronchial) region of the lung. Depends on the particle size
     REAL(wp) ::  mean_d   !< Particle diameter in micrometres
-    REAL(wp) ::  nc       !< Particle number concentration in units 1/cm**3
     REAL(wp) ::  temp_bin !< temporary variable
 
